package com.kt.print;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.Manifest;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.content.pm.PackageManager;
import java.util.ArrayList;
import java.io.IOException;

import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.PluginResult;
import org.apache.cordova.PermissionHelper;

import rego.printlib.export.regoPrinter;
import android.widget.Toast;

import com.kt.print.DeviceControl;

public class KTPrint extends CordovaPlugin {
	public boolean mBconnect = false;
	
	private regoPrinter printer;
	private int myState = 0;
	 
	public KTPrint() {}
	@Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) {
		printer = new regoPrinter(this.cordova.getActivity().getApplicationContext());
		//System.out.println(printer); 		
		//Toast.makeText(this.cordova.getActivity(),"xxx", Toast.LENGTH_LONG).show();
		openconnect("");
        if (action.equals("Print")) {
            JSONObject obj = args.optJSONObject(0);
            if (obj != null) {
                String param = obj.optString("param");

                if (param == null) {
                    callbackContext.error("User did not specify data to param");
                    return true;
                }
                Print(param);
            } else {
                callbackContext.error("User did not specify data to param");
                return true;
            }
        } else if (action.equals("PrintNLine")) {
            JSONObject obj = args.optJSONObject(0);
            if (obj != null) {
                String lines = obj.optString("lines");

                if (lines == null) {
                    callbackContext.error("User did not specify data to lines");
                    return true;
                }
                //PrintNLine();
            } else {
                callbackContext.error("User did not specify data to lines");
                return true;
            }
        } else {
            return false;
        }
        return true;
    }

	private DeviceControl DevCtrl;
	public void openconnect(String port) {
		// /dev/ttyMT1:115200 //kt45
		// /dev/ttyG1:115200 //tt43
		//Toast.makeText(this.cordova.getActivity(),"222", Toast.LENGTH_LONG).show();
		if (mBconnect) {
			printer.CON_CloseDevices(myState);			
			mBconnect = false;
		} else {
			modelJudgmen();
			System.out.println("----RG---CON_ConnectDevices");
			if (myState > 0) {
				mBconnect = true;
			} else {
				mBconnect = false;
			}
		}
	}
	private boolean isTT43 = false;

	private void modelJudgmen() {
		//Toast.makeText(this.cordova.getActivity(),"111", Toast.LENGTH_LONG).show();
		myState = printer.CON_ConnectDevices("RG-E487",
				"/dev/ttyMT1:115200", 200);	
		
		// kt45
		if (android.os.Build.VERSION.RELEASE.equals("4.4.2")) {
			DevCtrl = new DeviceControl(DeviceControl.powerPathKT);
			isTT43 = false;
			try {
				DevCtrl.PowerOnMTDevice();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		// 45q gpio
		else if (android.os.Build.VERSION.RELEASE.equals("5.1")) {
			DevCtrl = new DeviceControl(DeviceControl.powerPathKT);
			DevCtrl.setGpio(94);
			isTT43 = false;
			try {
				DevCtrl.PowerOnMTDevice();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		// // TT43
		else if (android.os.Build.VERSION.RELEASE.equals("4.0.3")) {
			// /dev/ttyG1:115200
			myState = printer.CON_ConnectDevices("RG-E487",
					"/dev/ttyG1:115200", 200);
			DevCtrl = new DeviceControl(DeviceControl.powerPathTT);
			isTT43 = true;
			try {
				DevCtrl.PowerOnDevice();
			} catch (IOException e) {
				e.printStackTrace();
			}

		}
	}

	// 
	
	public void Print(String param) {
		Log.i("test","--------------------------------------------------------------------------"+param);
		printer.CON_PageStart(myState,false,0,0);
		printer.ASCII_CtrlAlignType(myState,1);
		printer.ASCII_PrintString(myState,0,0, 1, 0, 0, param, "gb2312");
		printer.ASCII_CtrlPrintCRLF(myState,1);
		printer.ASCII_CtrlPrintCRLF(myState,1);
		printer.ASCII_CtrlPrintCRLF(myState,1);
		printer.ASCII_CtrlPrintCRLF(myState,1);
		//printer.ASCII_Print2DBarcode(myState,BarcodeType.BT_QRcode.getValue(),"123456789",8,76,2);
		printer.ASCII_CtrlReset(myState);
		printer.CON_PageEnd(myState,0);

		//printer = new regoPrinter(this.cordova.getActivity().getBaseContext());
		
		//myState = printer.CON_ConnectDevices("RG-MTP58B","/dev/ttyMT1:115200", 200);
		
		//getField(printer); 
		//Toast.makeText(this.cordova.getActivity(),"conn:"+String.valueOf(myState), Toast.LENGTH_LONG).show();
		//byte[] bytes = param.getBytes();
		//printer.ASCII_PrintBuffer(myState, bytes,bytes.length);
		//printer.CON_ConnectDevices("RG-MTP58B", false, 0, 0);
		//printer.CON_PageStart(myState, false, 400, 320);
		
		//printer.CON_SetPrintDirection(myState, 0);
		//ArrayList<String> param2 = new ArrayList<String>();
		//param2.add("28");
		//param2.add("30");
		//param2.add("TSS24.BF2");
		//param2.add("0");
		//param2.add("1");
		//param2.add("1");
		//param2.add("10-19 08:27");
		//printer.ASCII_PrintString(myState, param2,"gb2312");
		//Toast.makeText(this.cordova.getActivity(),"open:"+String.valueOf(printer.ASCII_PrintString(myState, param2,"gb2312")), Toast.LENGTH_LONG).show();
		//param2.clear();
		//param2.add("20");
		//param2.add("60");
		//param2.add("190");
		//param2.add("2");
		//printer.ASCII_PrintLine(myState, param2);
		//printer.CON_PageEnd(myState,0);
		openconnect("");
	}
}